@use "../sable";

$perc-width: (
  1\/2: 50%,
  1\/3: 33.333333%,
  2\/3: 66.666667%,
  1\/4: 25%,
  2\/4: 50%,
  3\/4: 75%,
  1\/5: 20%,
  2\/5: 40%,
  3\/5: 60%,
  4\/5: 80%,
  1\/6: 16.666667%,
  2\/6: 33.333333%,
  3\/6: 50%,
  4\/6: 66.666667%,
  5\/6: 83.333333%,
  1\/10: 10%,
  2\/10: 20%,
  3\/10: 30%,
  4\/10: 40%,
  5\/10: 50%,
  6\/10: 60%,
  7\/10: 70%,
  8\/10: 80%,
  9\/10: 90%,
  1\/12: 8.333333%,
  2\/12: 16.666667%,
  3\/12: 25%,
  4\/12: 33.333333%,
  5\/12: 41.666667%,
  6\/12: 50%,
  7\/12: 58.333333%,
  8\/12: 66.666667%,
  9\/12: 75%,
  10\/12: 83.333333%,
  11\/12: 91.666667%,
);

$perc-height: (
  1\/2: 50%,
  1\/3: 33.333333%,
  2\/3: 66.666667%,
  1\/4: 25%,
  2\/4: 50%,
  3\/4: 75%,
  1\/5: 20%,
  2\/5: 40%,
  3\/5: 60%,
  4\/5: 80%,
  1\/6: 16.666667%,
  2\/6: 33.333333%,
  3\/6: 50%,
  4\/6: 66.666667%,
  5\/6: 83.333333%,
  1\/10: 10%,
  2\/10: 20%,
  3\/10: 30%,
  4\/10: 40%,
  5\/10: 50%,
  6\/10: 60%,
  7\/10: 70%,
  8\/10: 80%,
  9\/10: 90%,
);

$spac: (
  0: 0,
  0\.5: 0.125rem,
  1: 0.25rem,
  1\.5: 0.375rem,
  2: 0.5rem,
  2\.5: 0.625rem,
  3: 0.75rem,
  3\.5: 0.875rem,
  4: 1rem,
  5: 1.25rem,
  6: 1.5rem,
  7: 1.75rem,
  8: 2rem,
  9: 2.25rem,
  10: 2.5rem,
  11: 2.75rem,
  12: 3rem,
  16: 4rem,
  20: 5rem,
  24: 6rem,
  28: 7rem,
  32: 8rem,
  36: 9rem,
  40: 10rem,
  44: 11rem,
  48: 12rem,
  52: 13rem,
  56: 14rem,
  60: 15rem,
  64: 16rem,
  72: 18rem,
  80: 20rem,
  96: 24rem,
) !default;

$widths: sable.fun-multiMapMerge($perc-width, $spac);
@each $name, $number in $widths {
  .w-#{$name},
  .before\:w-#{$name}::before,
  .after\:w-#{$name}::after {
    @include sable.size-width($number);
  }
}

$heights: sable.fun-multiMapMerge($perc-height, $spac);
@each $name, $number in $heights {
  .h-#{$name},
  .before\:h-#{$name}::before,
  .after\:h-#{$name}::after {
    @include sable.size-height($number);
  }
}

.w-auto {
  @include sable.size-width(auto);
}
.w-full {
  @include sable.size-width(100%);
}
.w-min {
  @include sable.size-width(min-content);
}
.w-max {
  @include sable.size-width(max-content);
}
.w-fit {
  @include sable.size-width(fit-content);
}

.min-w-full {
  @include sable.size-min-width(100%);
}
.min-w-screen {
  @include sable.size-min-width(100vw);
}
.min-w-min {
  @include sable.size-min-width(min-content);
}
.min-w-max {
  @include sable.size-min-width(max-content);
}
.min-w-fit {
  @include sable.size-min-width(fit-content);
}

.max-w-full {
  @include sable.size-max-width(100%);
}
.max-w-screen {
  @include sable.size-max-width(100vw);
}
.max-w-min {
  @include sable.size-max-width(min-content);
}
.max-w-max {
  @include sable.size-max-width(max-content);
}
.max-w-fit {
  @include sable.size-max-width(fit-content);
}

.h-auto {
  @include sable.size-height(auto);
}
.h-full {
  @include sable.size-height(100%);
}
.h-screen {
  @include sable.size-height(100vh);
}
.h-min {
  @include sable.size-height(min-content);
}
.h-max {
  @include sable.size-height(max-content);
}
.h-fit {
  @include sable.size-height(fit-content);
}

.min-h-full {
  @include sable.size-min-height(100%);
}
.min-h-screen {
  @include sable.size-min-height(100vh);
}
.min-h-min {
  @include sable.size-min-height(min-content);
}
.min-h-max {
  @include sable.size-min-height(max-content);
}
.min-h-fit {
  @include sable.size-min-height(fit-content);
}

.max-h-full {
  @include sable.size-max-height(100%);
}
.max-h-screen {
  @include sable.size-max-height(100vh);
}
.max-h-min {
  @include sable.size-max-height(min-content);
}
.max-h-max {
  @include sable.size-max-height(max-content);
}
.max-h-fit {
  @include sable.size-max-height(fit-content);
}

@each $bpName, $width in sable.$fun-breakpoints {
  @media (min-width: #{$width}) {
    @each $name, $number in $widths {
      .#{$bpName}\:w-#{$name},
      .#{$bpName}\:before\:w-#{$name}::before,
      .#{$bpName}\:after\:w-#{$name}::after {
        @include sable.size-width($number);
      }
    }
    
    @each $name, $number in $heights {
      .#{$bpName}\:h-#{$name},
      .#{$bpName}\:before\:h-#{$name}::before,
      .#{$bpName}\:after\:h-#{$name}::after {
        @include sable.size-height($number);
      }
    }
    
    .#{$bpName}\:w-auto {
      @include sable.size-width(auto);
    }
    .#{$bpName}\:w-full {
      @include sable.size-width(100%);
    }
    .#{$bpName}\:w-min {
      @include sable.size-width(min-content);
    }
    .#{$bpName}\:w-max {
      @include sable.size-width(max-content);
    }
    .#{$bpName}\:w-fit {
      @include sable.size-width(fit-content);
    }
    
    .#{$bpName}\:min-w-full {
      @include sable.size-min-width(100%);
    }
    .#{$bpName}\:min-w-screen {
      @include sable.size-min-width(100vw);
    }
    .#{$bpName}\:min-w-min {
      @include sable.size-min-width(min-content);
    }
    .#{$bpName}\:min-w-max {
      @include sable.size-min-width(max-content);
    }
    .#{$bpName}\:min-w-fit {
      @include sable.size-min-width(fit-content);
    }
    
    .#{$bpName}\:max-w-full {
      @include sable.size-max-width(100%);
    }
    .#{$bpName}\:max-w-screen {
      @include sable.size-max-width(100vw);
    }
    .#{$bpName}\:max-w-min {
      @include sable.size-max-width(min-content);
    }
    .#{$bpName}\:max-w-max {
      @include sable.size-max-width(max-content);
    }
    .#{$bpName}\:max-w-fit {
      @include sable.size-max-width(fit-content);
    }
    
    .#{$bpName}\:h-auto {
      @include sable.size-height(auto);
    }
    .#{$bpName}\:h-full {
      @include sable.size-height(100%);
    }
    .#{$bpName}\:h-screen {
      @include sable.size-height(100vh);
    }
    .#{$bpName}\:h-min {
      @include sable.size-height(min-content);
    }
    .#{$bpName}\:h-max {
      @include sable.size-height(max-content);
    }
    .#{$bpName}\:h-fit {
      @include sable.size-height(fit-content);
    }
    
    .#{$bpName}\:min-h-full {
      @include sable.size-min-height(100%);
    }
    .#{$bpName}\:min-h-screen {
      @include sable.size-min-height(100vh);
    }
    .#{$bpName}\:min-h-min {
      @include sable.size-min-height(min-content);
    }
    .#{$bpName}\:min-h-max {
      @include sable.size-min-height(max-content);
    }
    .#{$bpName}\:min-h-fit {
      @include sable.size-min-height(fit-content);
    }
    
    .#{$bpName}\:max-h-full {
      @include sable.size-max-height(100%);
    }
    .#{$bpName}\:max-h-screen {
      @include sable.size-max-height(100vh);
    }
    .#{$bpName}\:max-h-min {
      @include sable.size-max-height(min-content);
    }
    .#{$bpName}\:max-h-max {
      @include sable.size-max-height(max-content);
    }
    .#{$bpName}\:max-h-fit {
      @include sable.size-max-height(fit-content);
    }
  }
}
